﻿using UnityEngine;
using System.Collections;

public class Enemy : MonoBehaviour {

	public int enemyHealth;
	public int enemyDamage;
	public bool dead;
	public TextMesh enemyHealthDisplay;

	public Sprite[] enemySprites;
	public SpriteRenderer ren;

	private float maxSpeed = 3f;
	private float moveForce = 50f;
	public float horizontalInputDirection = 1;
	public float verticalInputDirection = -1;

	public Rigidbody2D bullet;
	public float speed = 20f;
	public bool canAttack;
	public GameObject[] bullets;



	void Awake(){

	}
	// Use this for initialization
	void Start () {
		int spriteIndex = Random.Range (0, enemySprites.Length);
		this.ren.sprite = enemySprites[spriteIndex];
		this.canAttack = true;
		this.enemyHealth = (int)(Random.Range (250, 500) * PlaythroughManager.Instance.playThroughNumber * 1.1f);

	
	}
	IEnumerator WaitForShoot(float waitTime){
		yield return new WaitForSeconds(waitTime);
		canAttack = true;
	}
	// Update is called once per frame
	void Update () {
		if (canAttack) {
			this.canAttack = false;
//			renderer.sprite = attackSprite;
			int bulletIndex = (int)Random.Range (0,1);
			GameObject bulletInstance = (GameObject)Instantiate(bullets[bulletIndex], transform.position, Quaternion.Euler(new Vector3(0,0,0)));
			bulletInstance.rigidbody2D.velocity = new Vector2(-speed, Random.Range (-3,3));
			StartCoroutine(WaitForShoot(Random.value));	
		}

		this.enemyHealthDisplay.text = "HP: " + enemyHealth.ToString();
		if (this.enemyHealth <= 0) {
			enemyHealth  = 0;
			Destroy(gameObject);

			Application.LoadLevel("winScreen");	
		}

		if(horizontalInputDirection * this.rigidbody2D.velocity.x < maxSpeed)
			// ... add a force to the player.
			this.rigidbody2D.AddForce(Vector2.right * horizontalInputDirection * moveForce);
		
		// If the player's horizontal velocity is greater than the maxSpeed...
		if(Mathf.Abs(this.rigidbody2D.velocity.x) > maxSpeed)
			// ... set the player's velocity to the maxSpeed in the x axis.
			this.rigidbody2D.velocity = new Vector2(Mathf.Sign(this.rigidbody2D.velocity.x) * maxSpeed, this.rigidbody2D.velocity.y);
		
		if(verticalInputDirection * this.rigidbody2D.velocity.y < maxSpeed)
			// ... add a force to the player.
			this.rigidbody2D.AddForce(Vector2.up * verticalInputDirection * moveForce);
		
		// If the player's horizontal velocity is greater than the maxSpeed...
		if(Mathf.Abs(this.rigidbody2D.velocity.y) > maxSpeed)
			// ... set the player's velocity to the maxSpeed in the x axis.
			this.rigidbody2D.velocity = new Vector2(this.rigidbody2D.velocity.x, Mathf.Sign(this.rigidbody2D.velocity.y) * maxSpeed);


	}
	void AttackPlayers(){
		Vector2 randomStartLeft = new Vector2 (Random.Range (-1,-7), Random.Range (-1,5));
		int bulletIndex = Random.Range(0,bullets.Length);
		Instantiate (bullets [bulletIndex], randomStartLeft, transform.rotation);
	}

	public void Hurt(int incomingDamage){
		enemyHealth -= incomingDamage;

	}
	void OnCollisionEnter2D(Collision2D collision){
		if (collision.collider.tag == "rightWall") {
			horizontalInputDirection *= -1;		
		}
		else{
			verticalInputDirection *= -1;
		}
	}
}
