﻿using UnityEngine;
using System.Collections;

public class Hero : MonoBehaviour {

	public float heroHealth;
	public int heroDamage;
	public int heroHeal;
	public char heroAttackKey;
	public HeroManager heroManager;
	public Enemy target;

	//Sprite management
	public Sprite idleSprite;
	public Sprite attackSprite;
	public SpriteRenderer currentSprite;
	public UnityEngine.UI.Image screenFlash;
	public TextMesh attackKey;

	//Character related text
	public GameObject charInfo;
	public string charClass;

	//Attack mecahnics
	public Rigidbody2D bullet;
	public float speed = 20f;
	public bool canAttack;
	public GameObject[] bullets;

	//Healthbar for players possibly
	public SpriteRenderer healthBar;
	private Vector3 healthScale = new Vector3(1,1,1);

	void Awake(){
		currentSprite = GetComponent<SpriteRenderer>();
	}

	public char GenerateAttackKey()
	{
		// This method returns a random lowercase letter.
		// ... Between 'a' and 'z' inclusize.
		int num = Random.Range(0, 26); // Zero to 25
		char let = (char)('a' + num);
		Debug.Log(let);
		return let;
	}
	// Use this for initialization
	void Start () {
		this.speed = (float)Random.Range (10,30);
		this.canAttack = true;
//		this.healthBar = GameObject.Find("HealthBar").GetComponent<SpriteRenderer>();
//		healthScale = healthBar.transform.localScale;
		this.target = GameObject.FindGameObjectWithTag("enemy").GetComponent<Enemy>();
		this.heroHealth = 100;//Random.Range(100,300);
		this.heroDamage = Random.Range (10,30) * PlaythroughManager.Instance.playThroughNumber/3;
		this.heroAttackKey = GenerateAttackKey();
		this.attackKey.text = this.heroAttackKey.ToString();
//		this.charInfo = this.charClass + "\nAttack with: " + this.heroAttackKey;
	}

	public void UpdateHealthBar (){
		healthBar.material.color = Color.Lerp (Color.red, Color.blue, 1-(this.heroHealth * 0.01f));
		healthBar.transform.localScale = new Vector3(healthScale.x * this.heroHealth * 0.01f, 1, 1);
	}
	// Update is called once per frame
	void Update () {
		if (this.canAttack && Input.GetKeyUp (heroAttackKey.ToString())) {
			this.canAttack = false;
			currentSprite.sprite = attackSprite;
			int bulletIndex = Random.Range(0,bullets.Length);
			GameObject bulletInstance = (GameObject)Instantiate(bullets[bulletIndex], transform.position, Quaternion.Euler(new Vector3(0,0,0)));
			bulletInstance.rigidbody2D.velocity = new Vector2(speed, 0);
			this.canAttack = true;		
		}

		if (this.heroHealth <= 0){
			Debug.Log(heroManager.currentHeroes);
			heroManager.currentHeroes -= 1;
			Debug.Log(heroManager.currentHeroes);
			Destroy(gameObject);
		}
	}

	public void TakeDamage(int incomingDamage){
		Debug.Log(this.heroHealth);
		this.heroHealth -= incomingDamage;
		UpdateHealthBar();
	}

}
