﻿using UnityEngine;
using System.Collections;

public class HeroManager : MonoBehaviour {

	
	public GameObject[] availableHeros;
	public int maxHeros;
	public int currentHeroes;
	private bool canSpawn;
	public int spawnCooldown;
	public UnityEngine.UI.Text currentHeroCountDisplay;
	public UnityEngine.UI.Text playthroughCountDisplay;
	
	// Use this for initialization
	void Start () {
		SpawnHero();
		currentHeroes++;
		canSpawn = false;
		spawnCooldown = 5;
		maxHeros = PlaythroughManager.Instance.playThroughNumber;
		if (maxHeros > 26){
			maxHeros = 26;
		}
	
	}
	
	// Update is called once per frame
	void Update () {
		if(PlaythroughManager.Instance.playThroughNumber > 1){
			currentHeroCountDisplay.text = "Heroes: " + currentHeroes.ToString();
			playthroughCountDisplay.text = "Playthrough: " + PlaythroughManager.Instance.playThroughNumber.ToString();
		}
		if (currentHeroes < 0){
			currentHeroes = 0;
		}
		if (Application.loadedLevelName == "game"){
			if (canSpawn && Input.GetAxis("SpawnPlayers")>0) {
				Debug.Log("Spawning");
				canSpawn =false;
				if (currentHeroes < maxHeros){
					SpawnHero();
				}
				else{
					Debug.Log("No more heroes");
					//Display some kind of message? Boot oldest hero out?
				}
			}
		}
	
	}

	void SpawnHero(){
		Vector2 randomStartLeft = new Vector2 (Random.Range (-1,-7), Random.Range (-1,5));
		int heroIndex = Random.Range(0,availableHeros.Length);
		Instantiate (availableHeros [heroIndex], randomStartLeft, transform.rotation);
		currentHeroes++;
		StartCoroutine(DelayNextSpawn());

	}
	IEnumerator DelayNextSpawn(){
		yield return new WaitForSeconds(spawnCooldown);
		canSpawn = true;
	}

}
